"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ng2_file_upload_1 = require("ng2-file-upload");
var base_component_1 = require("./base.component");
;
var FileUploadComponent = /** @class */ (function (_super) {
    __extends(FileUploadComponent, _super);
    function FileUploadComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.index = 0;
        _this.uploader = new ng2_file_upload_1.FileUploader({
            url: restRoot + "/common/files/upload",
            method: "POST",
            itemAlias: "uploadedfile"
        });
        return _this;
    }
    //  定义事件，选择文件
    FileUploadComponent.prototype.selectedFileOnChanged = function (event) {
        // 打印文件选择名称
        this.uploadFile(this.fileUploadInfo);
    };
    //  定义事件，上传文件
    FileUploadComponent.prototype.uploadFile = function (fileUploadInfo) {
        // 上传
        console.debug("length: " + this.uploader.queue.length);
        this.uploader.queue[this.index].onSuccess = function (response, status, headers) {
            fileUploadInfo.uploading = false;
            // 上传文件成功
            if (status == 200) {
                // 上传文件后获取服务器返回的数据
                console.debug(response);
                var tempRes = JSON.parse(response);
                console.debug("tempRes.uploadPaths:" + tempRes.uploadPaths);
                fileUploadInfo.uploadedFiles = fileUploadInfo.uploadedFiles.concat(tempRes.uploadPaths);
                fileUploadInfo.iconClass = "successmini";
                fileUploadInfo.message = "Uploaded";
            }
            else {
                fileUploadInfo.iconClass = "errormini";
                fileUploadInfo.message = "Upload failed";
            }
        };
        //fileUploadInfo.uploadedFiles = null;
        this.uploader.queue[this.index].upload(); // 开始上传
        this.index++;
        fileUploadInfo.uploading = true;
        fileUploadInfo.iconClass = "loadingmini";
        fileUploadInfo.message = "Uploading";
    };
    FileUploadComponent.prototype.isRunning = function () { return false; };
    __decorate([
        core_1.Input(),
        __metadata("design:type", FileUploadInfo)
    ], FileUploadComponent.prototype, "fileUploadInfo", void 0);
    FileUploadComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: "iisp-file-upload",
            template: "<input type='file' ng2FileSelect [uploader]='uploader' accept='{{fileUploadInfo.allowedFileType}}' [(ngModel)]=\"fileUploadInfo.fileInputValue\" (change)='selectedFileOnChanged($event)' />\n\t\t<span title='{{fileUploadInfo.message}}' [ngClass] = 'fileUploadInfo.iconClass'></span>"
        })
    ], FileUploadComponent);
    return FileUploadComponent;
}(base_component_1.BaseComponent));
exports.FileUploadComponent = FileUploadComponent;
var FileUploadInfo = /** @class */ (function () {
    function FileUploadInfo(allowedFileType) {
        this.uploadedFiles = new Array();
        this.uploading = false;
        this.iconClass = "blankmini";
        if (allowedFileType) {
            this.allowedFileType = allowedFileType;
        }
    }
    FileUploadInfo.prototype.reset = function () {
        this.fileInputValue = "";
        this.uploading = false;
        this.message = "";
        this.iconClass = "blankmini";
    };
    return FileUploadInfo;
}());
exports.FileUploadInfo = FileUploadInfo;
//# sourceMappingURL=fileupload.component.js.map