"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var utils_1 = require("./utils");
var MessageBoxComponent = /** @class */ (function () {
    function MessageBoxComponent() {
        this.msgs = [];
        this.isSticky = false;
        //constructor(private messageService: MessageService) {}
        this.header = utils_1.Utils.resolveLocalizedMessage('loading.data');
    }
    MessageBoxComponent.prototype.showMessage = function (style, msg) {
        this.msgs = [];
        this.isSticky = "error" == style;
        var title = utils_1.Utils.resolveLocalizedMessage("msg.type." + style);
        this.msgs.push({ severity: style, summary: title, detail: msg });
    };
    MessageBoxComponent.prototype.showMessages = function (style, msgs) {
        this.isSticky = "error" == style;
        for (var _i = 0, msgs_1 = msgs; _i < msgs_1.length; _i++) {
            var msg = msgs_1[_i];
            this.msgs = [];
            var title = utils_1.Utils.resolveLocalizedMessage("msg.type." + style);
            this.msgs.push({ severity: style, summary: title, detail: msg });
        }
    };
    MessageBoxComponent.prototype.getOffset = function () {
        //让消息框在屏幕可见区中间
        var clientWidth = document.documentElement.clientWidth;
        var clientHeight = document.documentElement.clientHeight;
        var top = document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop;
        var left = document.documentElement.scrollLeft ? document.documentElement.scrollLeft : document.body.scrollLeft;
        var x = (clientWidth - 100) / 2 + left;
        var y = (clientHeight - 30) / 2 + top;
        //console.debug("x=" + x + "y=" + y + "document.body.scrollTop=" + top);
        return { left: x, top: y };
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], MessageBoxComponent.prototype, "isRunning", void 0);
    MessageBoxComponent = __decorate([
        core_1.Component({
            selector: 'message-box',
            template: "<p-growl [(value)]=\"msgs\" [sticky]=\"isSticky\"></p-growl>\n\t    <p-dialog [modal]=\"true\" [header]=\"header\" [draggable]=\"false\" [closable]=\"false\" [visible]=\"isRunning\" [width]=\"150\" \n            [height]=\"188\" [minWidth]=\"148\" [minHeight]=\"128\" >\n        <div style=\"margin-left: 60px\" class=\"loading\"></div>\n\t</p-dialog>"
        })
    ], MessageBoxComponent);
    return MessageBoxComponent;
}());
exports.MessageBoxComponent = MessageBoxComponent;
//# sourceMappingURL=messagebox.component.js.map