import { TreeNode } from 'primeng/primeng';
import { RefBean, RefBeanTreeNode } from './models';
export declare class PrimengUtils {
    /** 把PrimeNg TreeNode数组转换成RefBean数组
     * @param treeNodes PrimeNg TreeNode数组，有data,label两个属性
     * @returns RefBean数组， 有code 和 name两个属性
     */
    static treeNodesToRefBeans(treeNodes: TreeNode[]): RefBean[];
    /** 根据已选的数据，把相应的PrimeNg TreeNode节点打上已选标记
     * @param treeNodes PrimeNg TreeNode数组，有data,label两个属性
     * @returns RefBean数组， 有code 和 name两个属性
     */
    static getSelectedTreeNodeByDatas(tree: TreeNode[], datas: string[]): TreeNode[];
    private static getSelectedTreeNodeByDatas1(treeNodes, datas, seletedTreeNodes);
    /** 从tree中找到与refBeans数组中ID相同的节点集。
     * @param tree 目标树，Primeng TreeNode树
     * @param refBeans 对应的refBeans，有code,name两个属性
     * @returns PrimeNg TreeNode树中，和refBeans中有相同ID的节点集
     */
    static getSelectedTreeNodes(tree: TreeNode[], refBeans: RefBean[]): TreeNode[];
    private static getSelectedNodes(treeNodes, refBeans, seletedTreeNodes);
    /** 把从服务器来的RefBeanTreeNode树变成PrimeNg TreeNode树，实际只是简单的把RefBean的code和name属性复制到data,label属性。
     * 这样简单处理后，需要返回到服务器端时，可以把PrimeNg TreeNode树直接当作RefBeanTreeNode树返回，无需变换。
     * @param rNodes 从服务器来的RefBean树，有code,name两个属性
     * @returns PrimeNg TreeNode树， 有data 和 label两个属性
     */
    static refBeanTreeNodesToTreeNodes(rNodes: RefBeanTreeNode[]): TreeNode[];
}
