import { Component, Input } from '@angular/core';
//import {SelectItem} from 'primeng/components/common/api';
import { Message } from 'primeng/components/common/api';
import { MessageService } from 'primeng/components/common/messageservice';
import { Utils } from './utils';

@Component({
	selector: 'message-box',
	template: `<p-growl [(value)]="msgs" [sticky]="isSticky"></p-growl>
	    <p-dialog [modal]="true" [header]="header" [draggable]="false" [closable]="false" [visible]="isRunning" [width]="150" 
            [height]="188" [minWidth]="148" [minHeight]="128" >
        <div style="margin-left: 60px" class="loading"></div>
	</p-dialog>`
})
export class MessageBoxComponent {
	@Input() isRunning: boolean;
	msgs: Message[] = [];
	isSticky = false;
	//constructor(private messageService: MessageService) {}
	header = Utils.resolveLocalizedMessage('loading.data');
	showMessage(style: string, msg: string): void {
		this.msgs = [];
		this.isSticky = "error" == style;
		let title = Utils.resolveLocalizedMessage("msg.type." + style);
		this.msgs.push({ severity: style, summary: title, detail: msg });
	}
	showMessages(style: string, msgs: string[]): void {
		this.isSticky = "error" == style;
		for (let msg of msgs) {
			this.msgs = [];
			let title = Utils.resolveLocalizedMessage("msg.type." + style);
			this.msgs.push({ severity: style, summary: title, detail: msg });
		}
	}

	getOffset(): any {
		//让消息框在屏幕可见区中间
		let clientWidth = document.documentElement.clientWidth;
		let clientHeight = document.documentElement.clientHeight;
		let top = document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop;
		let left = document.documentElement.scrollLeft ? document.documentElement.scrollLeft : document.body.scrollLeft;
		let x = (clientWidth - 100) / 2 + left;
		let y = (clientHeight - 30) / 2 + top;
		//console.debug("x=" + x + "y=" + y + "document.body.scrollTop=" + top);
		return { left: x, top: y };
	}
}
